<?php
/**
 * 2019 Addify
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Academic Free License (AFL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://opensource.org/licenses/afl-3.0.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@prestashop.com so we can send you a copy immediately.
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade PrestaShop to newer
 * versions in the future. If you wish to customize PrestaShop for your
 * needs please refer to http://www.prestashop.com for more information.
 *
 *  @author    Addify
 *  @copyright 2019 Addify
 *  @license   http://opensource.org/licenses/afl-3.0.php
 */
if (!defined('_PS_VERSION_')) {
    exit;
}
class AdminAddifyadvanceurlsController extends ModuleAdminController {


	public function __construct()

	{

		$this->name = 'addifyadvanceurls';

		$this->bootstrap = true;

		$this->context = Context::getContext();

		parent::__construct();

	}



	public function renderList()

	{   $template = '/../../views/templates/admin/duplicate_urls.tpl';

		$d1 = $this->productdata();

		$d2 = $this->categorydata();

		$d3 = $this->Comparedata();

		$langs = Language::getLanguages();

		$langs = count($langs);

		$this->context->smarty->assign(array(

			'duplicate_product' => $d1,

			'duplicate_category' => $d2,

			'duplicate_compare' => $d3,

			'langs_active' => (int)$langs

		));



		parent::renderList();

		return $this->context->smarty->fetch(dirname(__FILE__).$template);

	}



	private function productdata()

	{

		$langs = Language::getLanguages();

		$langs = count($langs);

		return Db::getInstance()->executeS('

		SELECT DISTINCT `link_rewrite`, GROUP_CONCAT(DISTINCT `id_product`) as id_product, `name`, count(`link_rewrite`) as times

		FROM `'._DB_PREFIX_.'product_lang`

		GROUP BY `link_rewrite`

		HAVING COUNT(`link_rewrite`) > '.(int)$langs);

	}



	private function categorydata()

	{

		$langs = Language::getLanguages();

		$langs = count($langs);

		return Db::getInstance()->executeS('

		SELECT DISTINCT `link_rewrite`, GROUP_CONCAT(DISTINCT `id_category`) as id_category, `name`, count(`link_rewrite`) as times

		FROM `'._DB_PREFIX_.'category_lang`

		GROUP BY `link_rewrite`

		HAVING COUNT(`link_rewrite`) > '.(int)$langs);

	}



	private function Comparedata()

	{

		return Db::getInstance()->executeS('

		SELECT DISTINCT p.`link_rewrite`, p.`id_product`, c.`link_rewrite`, c.`id_category`

		FROM `'._DB_PREFIX_.'product_lang` p, `'._DB_PREFIX_.'category_lang` c

		WHERE p.`link_rewrite` = c.`link_rewrite`');

	}

}