{*
* 2021 Addify
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future. If you wish to customize PrestaShop for your
* needs please refer to http://www.prestashop.com for more information.
*
*  @author    Addify
*  @copyright 2021 Addify
*  @license   http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*  International Registered Trademark & Property of PrestaShop SA
*}

<div class="alert alert-info">These tables shows products and categories having same URL which should not happen.<br><strong>How to Fix Duplicate Product URLs?</strong><br>Go to <strong>Sell->Catalog->Products</strong>, Choose the duplicate product to <strong>edit</strong>, Go to <strong>SEO</strong> tab and Rewrite <strong>Friendly URL</strong> and press Save button!<br><strong>How to Fix Duplicate Category URLs?</strong><br>Go to <strong>Sell->Categories</strong>, Choose the duplicate category to <strong>edit</strong>, Rewrite <strong>Friendly URL</strong> and press Save button!</div>

<div class="bootstrap">
	<div class="alert alert-warning">
	<ul class="list-unstyled">
		<li><h4>Please Fix any duplicate Product URLs below to avoid 404 errors.</h4></li>
	</ul>
	</div>
</div>


<div class="panel">
	<div class="panel-heading"><i class="icon-cogs"></i> Product URLs</div>
	<div class="row row-margin-bottom">
	<table class="table">
		<thead>
			<tr>
				<th class="text-left"><span class="title_box active">IDs</span></th>
				<th class="text-left"><span class="title_box active">Name</span></th>
				<th class="text-left"><span class="title_box active" style="color: orange">Link Rewrite</span></th>
				<th class="text-center"><span class="title_box active">Occurance</span></th>
			</tr>
		</thead>
		<tbody>
			{if empty($duplicate_product)}
				<tr><td>No Collisions found</td></tr>
			{else}
				{foreach from=$duplicate_product item=duplicate}
					<tr>
						<td class="text-left" style="max-width: 200px; word-wrap: break-word;">{$duplicate.id_product|escape:'htmlall':'UTF-8'}</td>
						<td class="text-left">{$duplicate.name|escape:'htmlall':'UTF-8'}</td>
						<td class="text-left">{$duplicate.link_rewrite|escape:'htmlall':'UTF-8'}</td>
						<td class="text-center">{if $langs_active > 1}{$duplicate.times|escape:'htmlall':'UTF-8' - $langs_active|escape:'htmlall':'UTF-8'}{else}{$duplicate.times|escape:'htmlall':'UTF-8'}{/if}</td>
					</tr>
				{/foreach}
			{/if}
		</tbody>
	</table>
</div>
</div>

<div class="bootstrap">
	<div class="alert alert-warning">
	<ul class="list-unstyled">
		<li><h4>Please Fix any duplicate Category URLs below to avoid 404 errors.</h4></li>
	</ul>
	</div>
</div>

<div class="panel">
	<div class="panel-heading"><i class="icon-cogs"></i> Category URLs</div>
	<div class="row row-margin-bottom">
	<table class="table">
		<thead>
			<tr>
				<th class="text-left"><span class="title_box active">IDs</span></th>
				<th class="text-left"><span class="title_box active">Name</span></th>
				<th class="text-left"><span class="title_box active" style="color: orange">Link Rewrite</span></th>
				<th class="text-center"><span class="title_box active">Occurance</span></th>
			</tr>
		</thead>
		<tbody>
			{if empty($duplicate_category)}
				<tr><td>No Collisions found</td></tr>
			{else}
			{foreach from=$duplicate_category item=duplicate}
				<tr>
					<td class="text-left" style="max-width: 200px; word-wrap: break-word;">{$duplicate.id_category|escape:'htmlall':'UTF-8'}</td>
					<td class="text-left">{$duplicate.name|escape:'htmlall':'UTF-8'}</td>
					<td class="text-left">{$duplicate.link_rewrite|escape:'htmlall':'UTF-8'}</td>
					<td class="text-center">{if $langs_active > 1}{$duplicate.times|escape:'htmlall':'UTF-8' - $langs_active|escape:'htmlall':'UTF-8'}{else}{$duplicate.times|escape:'htmlall':'UTF-8'}{/if}</td>
				</tr>
			{/foreach}
			{/if}
		</tbody>
	</table>
</div>
</div>

<div class="bootstrap">
	<div class="alert alert-warning">
	<ul class="list-unstyled">
		<li><h4>Please Fix any Conflicts between Product and Category URLs below to avoid 404 errors.</h4></li>
	</ul>
	</div>
</div>

<div class="panel">
	<div class="panel-heading"><i class="icon-cogs"></i> Conflicts Between Category and Product URLs</div>
	<div class="row row-margin-bottom">
	<table class="table">
		<thead>
			<tr>
				<th class="text-left"><span class="title_box active">ID Product</span></th>
				<th class="text-left"><span class="title_box active">ID Category</span></th>
				<th class="text-left"><span class="title_box active" style="color: orange">Shared Link Rewrite</span></th>
			</tr>
		</thead>
		<tbody>
			{if empty($duplicate_compare)}
				<tr><td>No Collisions found</td></tr>
			{else}
			{foreach from=$duplicate_compare item=duplicate}
				<tr>
					<td class="text-left">{$duplicate.id_product|escape:'htmlall':'UTF-8'}</td>
					<td class="text-left">{$duplicate.id_category|escape:'htmlall':'UTF-8'}</td>
					<td class="text-left">{$duplicate.link_rewrite|escape:'htmlall':'UTF-8'}</td>
				</tr>
			{/foreach}
			{/if}
		</tbody>
	</table>
</div>
</div>
